=begin
#Dependency-Track API

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 3.8.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module DependencyTracker
  class DependencyApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Adds one or more components as a dependency to a project
    # @param [Hash] opts the optional parameters
    # @option opts [DependencyRequest] :body 
    # @return [nil]
    def add_dependency(opts = {})
      add_dependency_with_http_info(opts)
      nil
    end

    # Adds one or more components as a dependency to a project
    # @param [Hash] opts the optional parameters
    # @option opts [DependencyRequest] :body 
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def add_dependency_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DependencyApi.add_dependency ...'
      end
      # resource path
      local_var_path = '/v1/dependency'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DependencyApi#add_dependency\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a list of all dependencies for a specific component
    # @param uuid [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<Dependency>]
    def get_dependencies_by_component(uuid, opts = {})
      data, _status_code, _headers = get_dependencies_by_component_with_http_info(uuid, opts)
      data
    end

    # Returns a list of all dependencies for a specific component
    # @param uuid [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Dependency>, Integer, Hash)>] Array<Dependency> data, response status code and response headers
    def get_dependencies_by_component_with_http_info(uuid, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DependencyApi.get_dependencies_by_component ...'
      end
      # verify the required parameter 'uuid' is set
      if @api_client.config.client_side_validation && uuid.nil?
        fail ArgumentError, "Missing the required parameter 'uuid' when calling DependencyApi.get_dependencies_by_component"
      end
      # resource path
      local_var_path = '/v1/dependency/component/{uuid}'.sub('{' + 'uuid' + '}', CGI.escape(uuid.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Array<Dependency>' 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DependencyApi#get_dependencies_by_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a list of all dependencies for a specific project
    # @param uuid [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<Dependency>]
    def get_dependencies_by_project(uuid, opts = {})
      data, _status_code, _headers = get_dependencies_by_project_with_http_info(uuid, opts)
      data
    end

    # Returns a list of all dependencies for a specific project
    # @param uuid [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Dependency>, Integer, Hash)>] Array<Dependency> data, response status code and response headers
    def get_dependencies_by_project_with_http_info(uuid, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DependencyApi.get_dependencies_by_project ...'
      end
      # verify the required parameter 'uuid' is set
      if @api_client.config.client_side_validation && uuid.nil?
        fail ArgumentError, "Missing the required parameter 'uuid' when calling DependencyApi.get_dependencies_by_project"
      end
      # resource path
      local_var_path = '/v1/dependency/project/{uuid}'.sub('{' + 'uuid' + '}', CGI.escape(uuid.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Array<Dependency>' 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DependencyApi#get_dependencies_by_project\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Removes a component as a dependency from a project
    # @param [Hash] opts the optional parameters
    # @option opts [DependencyRequest] :body 
    # @return [nil]
    def remove_dependency(opts = {})
      remove_dependency_with_http_info(opts)
      nil
    end

    # Removes a component as a dependency from a project
    # @param [Hash] opts the optional parameters
    # @option opts [DependencyRequest] :body 
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def remove_dependency_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DependencyApi.remove_dependency ...'
      end
      # resource path
      local_var_path = '/v1/dependency'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DependencyApi#remove_dependency\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
