=begin
#Dependency-Track API

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 3.8.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module DependencyTracker
  class LicenseApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Returns a specific license
    # @param license_id [String] The SPDX License ID of the license to retrieve
    # @param [Hash] opts the optional parameters
    # @return [License]
    def get_license(license_id, opts = {})
      data, _status_code, _headers = get_license_with_http_info(license_id, opts)
      data
    end

    # Returns a specific license
    # @param license_id [String] The SPDX License ID of the license to retrieve
    # @param [Hash] opts the optional parameters
    # @return [Array<(License, Integer, Hash)>] License data, response status code and response headers
    def get_license_with_http_info(license_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LicenseApi.get_license ...'
      end
      # verify the required parameter 'license_id' is set
      if @api_client.config.client_side_validation && license_id.nil?
        fail ArgumentError, "Missing the required parameter 'license_id' when calling LicenseApi.get_license"
      end
      # resource path
      local_var_path = '/v1/license/{licenseId}'.sub('{' + 'licenseId' + '}', CGI.escape(license_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'License' 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LicenseApi#get_license\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a concise listing of all licenses
    # @param [Hash] opts the optional parameters
    # @return [Array<License>]
    def get_license_listing(opts = {})
      data, _status_code, _headers = get_license_listing_with_http_info(opts)
      data
    end

    # Returns a concise listing of all licenses
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<License>, Integer, Hash)>] Array<License> data, response status code and response headers
    def get_license_listing_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LicenseApi.get_license_listing ...'
      end
      # resource path
      local_var_path = '/v1/license/concise'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Array<License>' 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LicenseApi#get_license_listing\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a list of all licenses with complete metadata for each license
    # @param [Hash] opts the optional parameters
    # @return [Array<License>]
    def get_licenses(opts = {})
      data, _status_code, _headers = get_licenses_with_http_info(opts)
      data
    end

    # Returns a list of all licenses with complete metadata for each license
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<License>, Integer, Hash)>] Array<License> data, response status code and response headers
    def get_licenses_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LicenseApi.get_licenses ...'
      end
      # resource path
      local_var_path = '/v1/license'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Array<License>' 

      # auth_names
      auth_names = opts[:auth_names] || ['X-Api-Key']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LicenseApi#get_licenses\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
