=begin
#Dependency-Track API

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 3.8.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module DependencyTracker
  class ConfigProperty
    attr_accessor :group_name

    attr_accessor :property_name

    attr_accessor :property_value

    attr_accessor :property_type

    attr_accessor :description

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'group_name' => :'groupName',
        :'property_name' => :'propertyName',
        :'property_value' => :'propertyValue',
        :'property_type' => :'propertyType',
        :'description' => :'description'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'group_name' => :'String',
        :'property_name' => :'String',
        :'property_value' => :'String',
        :'property_type' => :'String',
        :'description' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `DependencyTracker::ConfigProperty` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `DependencyTracker::ConfigProperty`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'group_name')
        self.group_name = attributes[:'group_name']
      end

      if attributes.key?(:'property_name')
        self.property_name = attributes[:'property_name']
      end

      if attributes.key?(:'property_value')
        self.property_value = attributes[:'property_value']
      end

      if attributes.key?(:'property_type')
        self.property_type = attributes[:'property_type']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@group_name.nil? && @group_name.to_s.length > 255
        invalid_properties.push('invalid value for "group_name", the character length must be smaller than or equal to 255.')
      end

      if !@group_name.nil? && @group_name.to_s.length < 1
        invalid_properties.push('invalid value for "group_name", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !@group_name.nil? && @group_name !~ pattern
        invalid_properties.push("invalid value for \"group_name\", must conform to the pattern #{pattern}.")
      end

      if !@property_name.nil? && @property_name.to_s.length > 255
        invalid_properties.push('invalid value for "property_name", the character length must be smaller than or equal to 255.')
      end

      if !@property_name.nil? && @property_name.to_s.length < 1
        invalid_properties.push('invalid value for "property_name", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !@property_name.nil? && @property_name !~ pattern
        invalid_properties.push("invalid value for \"property_name\", must conform to the pattern #{pattern}.")
      end

      if !@property_value.nil? && @property_value.to_s.length > 1024
        invalid_properties.push('invalid value for "property_value", the character length must be smaller than or equal to 1024.')
      end

      if !@property_value.nil? && @property_value.to_s.length < 0
        invalid_properties.push('invalid value for "property_value", the character length must be great than or equal to 0.')
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !@property_value.nil? && @property_value !~ pattern
        invalid_properties.push("invalid value for \"property_value\", must conform to the pattern #{pattern}.")
      end

      if @property_type.nil?
        invalid_properties.push('invalid value for "property_type", property_type cannot be nil.')
      end

      if !@description.nil? && @description.to_s.length > 255
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length < 0
        invalid_properties.push('invalid value for "description", the character length must be great than or equal to 0.')
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !@description.nil? && @description !~ pattern
        invalid_properties.push("invalid value for \"description\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@group_name.nil? && @group_name.to_s.length > 255
      return false if !@group_name.nil? && @group_name.to_s.length < 1
      return false if !@group_name.nil? && @group_name !~ Regexp.new(/[\P{Cc}]+/)
      return false if !@property_name.nil? && @property_name.to_s.length > 255
      return false if !@property_name.nil? && @property_name.to_s.length < 1
      return false if !@property_name.nil? && @property_name !~ Regexp.new(/[\P{Cc}]+/)
      return false if !@property_value.nil? && @property_value.to_s.length > 1024
      return false if !@property_value.nil? && @property_value.to_s.length < 0
      return false if !@property_value.nil? && @property_value !~ Regexp.new(/[\P{Cc}]+/)
      return false if @property_type.nil?
      property_type_validator = EnumAttributeValidator.new('String', ["BOOLEAN", "INTEGER", "NUMBER", "STRING", "ENCRYPTEDSTRING", "TIMESTAMP", "URL", "UUID"])
      return false unless property_type_validator.valid?(@property_type)
      return false if !@description.nil? && @description.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length < 0
      return false if !@description.nil? && @description !~ Regexp.new(/[\P{Cc}]+/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] group_name Value to be assigned
    def group_name=(group_name)
      if !group_name.nil? && group_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "group_name", the character length must be smaller than or equal to 255.'
      end

      if !group_name.nil? && group_name.to_s.length < 1
        fail ArgumentError, 'invalid value for "group_name", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !group_name.nil? && group_name !~ pattern
        fail ArgumentError, "invalid value for \"group_name\", must conform to the pattern #{pattern}."
      end

      @group_name = group_name
    end

    # Custom attribute writer method with validation
    # @param [Object] property_name Value to be assigned
    def property_name=(property_name)
      if !property_name.nil? && property_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "property_name", the character length must be smaller than or equal to 255.'
      end

      if !property_name.nil? && property_name.to_s.length < 1
        fail ArgumentError, 'invalid value for "property_name", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !property_name.nil? && property_name !~ pattern
        fail ArgumentError, "invalid value for \"property_name\", must conform to the pattern #{pattern}."
      end

      @property_name = property_name
    end

    # Custom attribute writer method with validation
    # @param [Object] property_value Value to be assigned
    def property_value=(property_value)
      if !property_value.nil? && property_value.to_s.length > 1024
        fail ArgumentError, 'invalid value for "property_value", the character length must be smaller than or equal to 1024.'
      end

      if !property_value.nil? && property_value.to_s.length < 0
        fail ArgumentError, 'invalid value for "property_value", the character length must be great than or equal to 0.'
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !property_value.nil? && property_value !~ pattern
        fail ArgumentError, "invalid value for \"property_value\", must conform to the pattern #{pattern}."
      end

      @property_value = property_value
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] property_type Object to be assigned
    def property_type=(property_type)
      validator = EnumAttributeValidator.new('String', ["BOOLEAN", "INTEGER", "NUMBER", "STRING", "ENCRYPTEDSTRING", "TIMESTAMP", "URL", "UUID"])
      unless validator.valid?(property_type)
        fail ArgumentError, "invalid value for \"property_type\", must be one of #{validator.allowable_values}."
      end
      @property_type = property_type
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 255
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 255.'
      end

      if !description.nil? && description.to_s.length < 0
        fail ArgumentError, 'invalid value for "description", the character length must be great than or equal to 0.'
      end

      pattern = Regexp.new(/[\P{Cc}]+/)
      if !description.nil? && description !~ pattern
        fail ArgumentError, "invalid value for \"description\", must conform to the pattern #{pattern}."
      end

      @description = description
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          group_name == o.group_name &&
          property_name == o.property_name &&
          property_value == o.property_value &&
          property_type == o.property_type &&
          description == o.description
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [group_name, property_name, property_value, property_type, description].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        DependencyTracker.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
